lightoj 1011 Marriage Ceremonies (暴力)(记忆化dp,状压) 转

转载自:http://blog.csdn.net/xindoo/article/details/9173949

暴力TLE

 1 #include <iostream>
 2 #include <string.h>
 3 #include <algorithm>
 4
 5 using namespace std;
 6
 7 int vis[17];
 8 int n, ans, sum;
 9 int map[19][19];
10
11 void dfs(int x)
12 {
13     if (x == n+1)
14     {
15         ans = max(ans, sum);
16         return;
17     }
18     for (int i = 1; i <= n; i++)
19     {
20         if (vis[i] == 0)
21         {
22             sum += map[x][i];
23             vis[i] = 1;
24             dfs(x+1);
25             vis[i] = 0;
26             sum -= map[x][i];
27         }
28     }
29 }
30 int main()
31 {
32     int t;
33     cin >> t;
34     for (int kase = 1; kase <= t; kase++)
35     {
36         cin >> n;
37         for (int i = 1; i <= n; i++)
38             for (int j = 1; j <= n; j++)
39                 cin >> map[i][j];
40         sum = 0;
41         ans = 0;
42         memset(vis, 0, sizeof(vis));
43         dfs(1);
44         cout << "Case " << kase << ": " << ans << endl;
45     }
46     return 0;
47 }

状态压缩+dp

//2013-06-25-22.05
#include <iostream>
#include <string.h>
#include <algorithm>
#include <stdio.h>

using namespace std;
const int maxn = 1<<16;
int vis[17];
int n, ans, sum;
int map[19][19];
int dp[maxn];
int dfs(int x, int d)
{
    if (x == 0)
        return 0;
    if (dp[x])
        return dp[x];
    for (int i = 0; i < n; i++)
    {
        if (x&(1<<i))
            dp[x] = max(dfs(x^(1<<i), d-1)+map[i+1][d], dp[x]);
    }
    return dp[x];
}
int main()
{
    int t;
    cin >> t;
    for (int kase = 1; kase <= t; kase++)
    {
        cin >> n;
        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= n; j++)
                cin >> map[i][j];
        memset(dp, 0, sizeof(dp));
        ans = dfs((1<<n)-1, n);
        printf("Case %d: %d\n", kase, ans);
    }
    return 0;
}
时间: 2024-10-06 08:39:27

lightoj 1011 Marriage Ceremonies (暴力)(记忆化dp,状压) 转的相关文章

Lightoj 1011 - Marriage Ceremonies

You work in a company which organizes marriages. Marriages are not that easy to be made, so, the job is quite hard for you. The job gets more difficult when people come here and give their bio-data with their preference about opposite gender. Some gi

URAL 1152. False Mirrors (记忆化搜索 状压DP)

题目链接 题意 : 每一颗子弹破坏了三个邻近的阳台.(第N个阳台是与第1个相邻)射击后后的生存的怪物都对主角造成伤害- 如此,直到所有的怪物被消灭,求怎样射击才能受到最少伤害. 思路 : 状压,数据不是很大,可以爆一爆,或者DFS下去就行,枚举每一种状态. 1 //1152 2 #include <cstdio> 3 #include <cstring> 4 #include <iostream> 5 #define oo 1 << 28 6 using n

HDU 4778 记忆化搜索&amp;状压

给出G种宝石,B个包,和S,S代表到时候每种颜色的宝石凑齐S个能变成一个魔法石 每个包里有N种宝石,分别为c1,c2....... 然后两人轮流拿包,每个包只能拿一次,拿出包把宝石放地上. 如果能变成魔法石则拿走魔法石,下一次还这个人拿包,没变成则换人. 魔法石的个数就是获得分数,问两人最优的时候分差是多少. 状压记忆化搜索 一共21个包,状压存当前取包的状态 无论怎样取,最后获得的魔法石数量一定 dp[i]表示在i状态下,先手可以获得的最高分数 #include "stdio.h"

LightOJ 1038 Race to 1 Again 期望 记忆化dp

题目链接:点击打开链接 1038 - Race to 1 Again PDF (English) Statistics Forum Time Limit: 2 second(s) Memory Limit: 32 MB Rimi learned a new thing about integers, which is - any positive integer greater than 1 can be divided by its divisors. So, he is now playin

cf779D(记忆化dp)

题目链接: http://codeforces.com/problemset/problem/799/D 题意: 给出两个矩阵边长 a, b, 和 w, h, 以及一个 c 数组, 可选择 c 数组中任意数字乘上w 或 h. 数组中每个数字最多只能用一次. 求最少选择多少个数字可使得边长为 a, b 的矩阵能放到变化后的矩阵中. 思路: log2(1e5) = 17, 即最多需要对一条边乘17个数字, 要是完全暴力的话需要 2^34 的时间复杂度, 显然不行. 本题 dp 可解, 先给 c 降序

POJ 1088 滑雪(简单的记忆化dp)

题目 又一道可以称之为dp的题目,虽然看了别人的代码,但是我的代码写的还是很挫,,,,,, //看了题解做的简单的记忆化dp #include<stdio.h> #include<algorithm> #include<iostream> using namespace std; int mp[110][110],dp[110][110]; int xx[]={1,-1,0,0}; int yy[]={0,0,1,-1}; int n,m; int dfs(int x,

UVA - 11324 The Largest Clique 强连通缩点+记忆化dp

题目要求一个最大的弱联通图. 首先对于原图进行强连通缩点,得到新图,这个新图呈链状,类似树结构. 对新图进行记忆化dp,求一条权值最长的链,每个点的权值就是当前强连通分量点的个数. /* Tarjan算法求有向图的强连通分量set记录了强连通分量 Col记录了强连通分量的个数. */ #include <iostream> #include<cstring> #include<cstdio> #include<string> #include<algo

BNU 25593 Prime Time 记忆化dp

题目链接:点击打开链接 题意: 一个游戏由3个人轮流玩 每局游戏由其中一名玩家选择一个数字作为开始 目的:获得最小的得分 对于当前玩家 O ,面对 u 这个数字 则他的操作有: 1. 计分 u +1 ,然后 u++; 2.计分 u / x, 然后 u /= x; 其中x为u的因子且x为素数 然后下一个玩家继续上述操作 3个人各操作一次 为1轮 当一轮结束后,若u==1 则游戏结束 每个人的得分为 他所有计分记录里最小的数字 若在一轮结束前 u就==1, 那么玩家的得分为本局游戏的初始数 求: 每

poj1692(区间记忆化dp)

题意:上下两行数相连,相等的才可以相连,并且每条线必须且只能与其他一条线相交(要同时满足相交的两条线的数不相等).问给的两行数最多可以连几条线. 解法:ans[i][j]记录着上面i,和下面j下标之后的数中最多可以连多少条,记忆化搜索dfs(0,0)就可以了.搜索时候,如果用到了i,则贪心在下面选相等的.用到j同理. 代码: /**************************************************** * author:xiefubao **************